var unicode_map = {
	// unicode standard
	":airplane:": "2708",
	":alarm_clock:": "23F0",
	":anchor:": "2693",
	":aquarius:": "2652",
	":aries:": "2648",
	":arrow_backward:": "25C0",
	":arrow_double_down:": "23EC",
	":arrow_double_up:": "23EB",
	":arrow_down:": "2B07",
	":arrow_forward:": "25B6",
	":arrow_heading_down:": "2935",
	":arrow_heading_up:": "2934",
	":arrow_left:": "2B05",
	":arrow_lower_left:": "2199",
	":arrow_lower_right:": "2198",
	":arrow_right:": "27A1",
	":arrow_right_hook:": "21AA",
	":arrow_up:": "2B06",
	":arrow_up_down:": "2195",
	":arrow_upper_left:": "2196",
	":arrow_upper_right:": "2197",
	":ballot_box_with_check:": "2611",
	":bangbang:": "203C",
	":cancer:": "264B",
	":baseball:": "26BE",
	":black_large_square:": "2B1B",
	":black_medium_small_square:": "25FE",
	":black_medium_square:": "25FC",
	":black_nib:": "2712",
	":black_small_square:": "25AA",
	":black_circle:": "26AB",
	":boat:": "26F5",
	":capricorn:": "2651",
	":church:": "26EA",
	":cloud:": "2601",
	":clubs:": "2663",
	":coffee:": "2615",
	":congratulations:": "3297",
	":copyright:": "A9", //"00A9",
	":curly_loop:": "27B0",
	":eight_pointed_black_star:": "2734",
	":eight_spoked_asterisk:": "2733",
	":diamonds:": "2666",
	":mail:": "2709",
	":email:": "1F4E7", //"2709",
	":envelope:": "2709",
	":exclamation:": "2757",
	":fast_forward:": "23E9",
	":fist:": "270A",
	":fountain:": "26F2",
	":fuelpump:": "26FD",
	":gemini:": "264A",
	":golf:": "26F3",
	":grey_exclamation:": "2755",
	":grey_question:": "2754",
	":hand:": "270B",
	":heart:": "2764",
	":hearts:": "2665",
	":heavy_check_mark:": "2714",
	":heavy_division_sign:": "2797",
	":heavy_exclamation_mark:": "2757",
	":heavy_minus_sign:": "2796",
	":heavy_multiplication_x:": "2716",
	":heavy_plus_sign:": "2795",
	":hotsprings:": "2668",
	":hourglass:": "231B",
	":hourglass_flowing_sand:": "23F3",
	":information_source:": "2139",
	":interrobang:": "2049",
	":left_right_arrow:": "2194",
	":leftwards_arrow_with_hook:": "21A9",
	":leo:": "264C",
	":libra:": "264E",
	":loop:": "27BF",
	":m:": "24C2",
	":negative_squared_cross_mark:": "274E",
	":no_entry:": "26D4",
	":o:": "2B55",
	":ophiuchus:": "26CE",
	":part_alternation_mark:": "303D",
	":partly_sunny:": "26C5",
	":pen:": "2712",
	":pencil:": "270F",
	":phone:": "260E",
	":pisces:": "2653",
	":point_up:": "261D",
	":question:": "2753",
	":raised_hand:": "270B",
	":recycle:": "267B",
	":registered:": "AE", //"00AE",
	":relaxed:": "263A",
	":rewind:": "23EA",
	":sagittarius:": "2650",
	":sailboat:": "26F5",
	":scissors:": "2702",
	":scorpius:": "264F",
	":secret:": "3299",
	":snowflake:": "2744",
	":snowman:": "26C4",
	":soccer:": "26BD",
	":spades:": "2660",
	":sparkle:": "2747",
	":sparkles:": "2728",
	":star:": "2B50",
	":sunny:": "2600",
	":taurus:": "2649",
	":telephone:": "260E",
	":tent:": "26FA",
	":tm:": "2122",
	":umbrella:": "2614",
	":v:": "270C",
	":virgo:": "264D",
	":warning:": "26A0",
	":watch:": "231A",
	":wavy_dash:": "3030",
	":wheelchair:": "267F",
	":white_check_mark:": "2705",
	":white_circle:": "26AA",
	":white_large_square:": "2B1C",
	":white_medium_small_square:": "25FD",
	":white_medium_square:": "25FB",
	":white_small_square:": "25AB",
	":x:": "274C",
	":zap:": "26A1",
	// unicode hexadecimal
	":+1:": "1F44D",
	":-1:": "1F44E",
	":100:": "1F4AF",
	":1234:": "1F522",
	":8ball:": "1F3B1",
	":a:": "1F170",
	":ab:": "1F18E",
	":abc:": "1F524",
	":abcd:": "1F521",
	":accept:": "1F251",
	":aerial_tramway:": "1F6A1",
	":alien:": "1F47D",
	":ambulance:": "1F691",
	":angel:": "1F47C",
	":anger:": "1F4A2",
	":angry:": "1F620",
	":anguished:": "1F627",
	":ant:": "1F41C",
	":apple:": "1F34E",
	":arrow_down_small:": "1F53D",
	":arrow_up_small:": "1F53C",
	":arrows_clockwise:": "1F503",
	":arrows_counterclockwise:": "1F504",
	":art:": "1F3A8",
	":articulated_lorry:": "1F69B",
	":astonished:": "1F632",
	":athletic_shoe:": "1F45F",
	":atm:": "1F3E7",
	":b:": "1F171",
	":baby:": "1F476",
	":baby_bottle:": "1F37C",
	":baby_chick:": "1F424",
	":baby_symbol:": "1F6BC",
	":back:": "1F519",
	":baggage_claim:": "1F6C4",
	":balloon:": "1F388",
	":bamboo:": "1F38D",
	":banana:": "1F34C",
	":bank:": "1F3E6",
	":bar_chart:": "1F4CA",
	":barber:": "1F488",
	":basketball:": "1F3C0",
	":bath:": "1F6C0",
	":bathtub:": "1F6C1",
	":battery:": "1F50B",
	":bear:": "1F43B",
	":bee:": "1F41D",
	":beer:": "1F37A",
	":beers:": "1F37B",
	":beetle:": "1F41E",
	":beginner:": "1F530",
	":bell:": "1F514",
	":bento:": "1F371",
	":bicyclist:": "1F6B4",
	":bike:": "1F6B2",
	":bikini:": "1F459",
	":bird:": "1F426",
	":birthday:": "1F382",
	":black_joker:": "1F0CF",
	":black_square_button:": "1F532",
	":blossom:": "1F33C",
	":blowfish:": "1F421",
	":blue_book:": "1F4D8",
	":blue_car:": "1F699",
	":blue_heart:": "1F499",
	":blush:": "1F60A",
	":boar:": "1F417",
	":bomb:": "1F4A3",
	":book:": "1F4D6",
	":bookmark:": "1F516",
	":bookmark_tabs:": "1F4D1",
	":books:": "1F4DA",
	":boom:": "1F4A5",
	":boot:": "1F462",
	":bouquet:": "1F490",
	":bow:": "1F647",
	":bowling:": "1F3B3",
	":boy:": "1F466",
	":bread:": "1F35E",
	":bride_with_veil:": "1F470",
	":bridge_at_night:": "1F309",
	":briefcase:": "1F4BC",
	":broken_heart:": "1F494",
	":bug:": "1F41B",
	":bulb:": "1F4A1",
	":bullettrain_front:": "1F685",
	":bullettrain_side:": "1F684",
	":bus:": "1F68C",
	":busstop:": "1F68F",
	":bust_in_silhouette:": "1F464",
	":busts_in_silhouette:": "1F465",
	":cactus:": "1F335",
	":cake:": "1F370",
	":calendar:": "1F4C6",
	":calling:": "1F4F2",
	":camel:": "1F42B",
	":camera:": "1F4F7",
	":candy:": "1F36C",
	":capital_abcd:": "1F520",
	":car:": "1F697",
	":card_index:": "1F4C7",
	":carousel_horse:": "1F3A0",
	":cat:": "1F431",
	":cat2:": "1F408",
	":cd:": "1F4BF",
	":chart:": "1F4B9",
	":chart_with_downwards_trend:": "1F4C9",
	":chart_with_upwards_trend:": "1F4C8",
	":checkered_flag:": "1F3C1",
	":cherries:": "1F352",
	":cherry_blossom:": "1F338",
	":chestnut:": "1F330",
	":chicken:": "1F414",
	":children_crossing:": "1F6B8",
	":chocolate_bar:": "1F36B",
	":christmas_tree:": "1F384",
	":cinema:": "1F3A6",
	":circus_tent:": "1F3AA",
	":city_sunrise:": "1F307",
	":city_sunset:": "1F306",
	":cl:": "1F191",
	":clap:": "1F44F",
	":clapper:": "1F3AC",
	":clipboard:": "1F4CB",
	":clock1:": "1F550",
	":clock10:": "1F559",
	":clock1030:": "1F565",
	":clock11:": "1F55A",
	":clock1130:": "1F566",
	":clock12:": "1F55B",
	":clock1230:": "1F567",
	":clock130:": "1F55C",
	":clock2:": "1F551",
	":clock230:": "1F55D",
	":clock3:": "1F552",
	":clock330:": "1F55E",
	":clock4:": "1F553",
	":clock430:": "1F55F",
	":clock5:": "1F554",
	":clock530:": "1F560",
	":clock6:": "1F555",
	":clock630:": "1F561",
	":clock7:": "1F556",
	":clock730:": "1F562",
	":clock8:": "1F557",
	":clock830:": "1F563",
	":clock9:": "1F558",
	":clock930:": "1F564",
	":closed_book:": "1F4D5",
	":closed_lock_with_key:": "1F510",
	":closed_umbrella:": "1F302",
	":cocktail:": "1F378",
	":cold_sweat:": "1F630",
	":collision:": "1F4A5",
	":computer:": "1F4BB",
	":confetti_ball:": "1F38A",
	":confounded:": "1F616",
	":confused:": "1F615",
	":construction:": "1F6A7",
	":construction_worker:": "1F477",
	":convenience_store:": "1F3EA",
	":cookie:": "1F36A",
	":cool:": "1F192",
	":cop:": "1F46E",
	":corn:": "1F33D",
	":couple:": "1F46B",
	":couple_with_heart:": "1F491",
	":couplekiss:": "1F48F",
	":cow:": "1F42E",
	":cow2:": "1F404",
	":credit_card:": "1F4B3",
	":crocodile:": "1F40A",
	":crossed_flags:": "1F38C",
	":crown:": "1F451",
	":cry:": "1F622",
	":crying_cat_face:": "1F63F",
	":crystal_ball:": "1F52E",
	":cupid:": "1F498",
	":currency_exchange:": "1F4B1",
	":curry:": "1F35B",
	":custard:": "1F36E",
	":customs:": "1F6C3",
	":cyclone:": "1F300",
	":dancer:": "1F483",
	":dancers:": "1F46F",
	":dango:": "1F361",
	":dart:": "1F3AF",
	":dash:": "1F4A8",
	":date:": "1F4C5",
	":deciduous_tree:": "1F333",
	":department_store:": "1F3EC",
	":diamond_shape_with_a_dot_inside:": "1F4A0",
	":disappointed:": "1F61E",
	":disappointed_relieved:": "1F625",
	":dizzy:": "1F4AB",
	":dizzy_face:": "1F635",
	":do_not_litter:": "1F6AF",
	":dog:": "1F436",
	":dog2:": "1F415",
	":dollar:": "1F4B5",
	":dolls:": "1F38E",
	":dolphin:": "1F42C",
	":door:": "1F6AA",
	":doughnut:": "1F369",
	":dragon:": "1F409",
	":dragon_face:": "1F432",
	":dress:": "1F457",
	":dromedary_camel:": "1F42A",
	":droplet:": "1F4A7",
	":dvd:": "1F4C0",
	":e-mail:": "1F4E7",
	":ear:": "1F442",
	":ear_of_rice:": "1F33E",
	":earth_africa:": "1F30D",
	":earth_americas:": "1F30E",
	":earth_asia:": "1F30F",
	":egg:": "1F373",
	":eggplant:": "1F346",
	":electric_plug:": "1F50C",
	":elephant:": "1F418",
	":end:": "1F51A",
	":envelope_with_arrow:": "1F4E9",
	":euro:": "1F4B6",
	":european_castle:": "1F3F0",
	":european_post_office:": "1F3E4",
	":evergreen_tree:": "1F332",
	":expressionless:": "1F611",
	":eyeglasses:": "1F453",
	":eyes:": "1F440",
	":facepunch:": "1F44A",
	":factory:": "1F3ED",
	":fallen_leaf:": "1F342",
	":family:": "1F46A",
	":fax:": "1F4E0",
	":fearful:": "1F628",
	":feet:": "1F43E",
	":ferris_wheel:": "1F3A1",
	":file_folder:": "1F4C1",
	":fire:": "1F525",
	":fire_engine:": "1F692",
	":fireworks:": "1F386",
	":first_quarter_moon:": "1F313",
	":first_quarter_moon_with_face:": "1F31B",
	":fish:": "1F41F",
	":fish_cake:": "1F365",
	":fishing_pole_and_fish:": "1F3A3",
	":flags:": "1F38F",
	":flashlight:": "1F526",
	":floppy_disk:": "1F4BE",
	":flower_playing_cards:": "1F3B4",
	":flushed:": "1F633",
	":foggy:": "1F301",
	":football:": "1F3C8",
	":footprints:": "1F463",
	":fork_and_knife:": "1F374",
	":four_leaf_clover:": "1F340",
	":free:": "1F193",
	":fried_shrimp:": "1F364",
	":fries:": "1F35F",
	":frog:": "1F438",
	":frowning:": "1F626",
	":full_moon:": "1F315",
	":full_moon_with_face:": "1F31D",
	":game_die:": "1F3B2",
	":gem:": "1F48E",
	":ghost:": "1F47B",
	":gift:": "1F381",
	":gift_heart:": "1F49D",
	":girl:": "1F467",
	":globe_with_meridians:": "1F310",
	":goat:": "1F410",
	":grapes:": "1F347",
	":green_apple:": "1F34F",
	":green_book:": "1F4D7",
	":green_heart:": "1F49A",
	":grimacing:": "1F62C",
	":grin:": "1F601",
	":grinning:": "1F600",
	":guardsman:": "1F482",
	":guitar:": "1F3B8",
	":gun:": "1F52B",
	":haircut:": "1F487",
	":hamburger:": "1F354",
	":hammer:": "1F528",
	":hamster:": "1F439",
	":handbag:": "1F45C",
	":hankey:": "1F4A9",
	":hatched_chick:": "1F425",
	":hatching_chick:": "1F423",
	":headphones:": "1F3A7",
	":hear_no_evil:": "1F649",
	":heart_decoration:": "1F49F",
	":heart_eyes:": "1F60D",
	":heart_eyes_cat:": "1F63B",
	":heartbeat:": "1F493",
	":heartpulse:": "1F497",
	":heavy_dollar_sign:": "1F4B2",
	":helicopter:": "1F681",
	":herb:": "1F33F",
	":hibiscus:": "1F33A",
	":high_brightness:": "1F506",
	":high_heel:": "1F460",
	":hocho:": "1F52A",
	":honey_pot:": "1F36F",
	":honeybee:": "1F41D",
	":horse:": "1F434",
	":horse_racing:": "1F3C7",
	":hospital:": "1F3E5",
	":hotel:": "1F3E8",
	":house:": "1F3E0",
	":house_with_garden:": "1F3E1",
	":hushed:": "1F62F",
	":ice_cream:": "1F368",
	":icecream:": "1F366",
	":id:": "1F194",
	":ideograph_advantage:": "1F250",
	":imp:": "1F47F",
	":inbox_tray:": "1F4E5",
	":incoming_envelope:": "1F4E8",
	":information_desk_person:": "1F481",
	":innocent:": "1F607",
	":iphone:": "1F4F1",
	":izakaya_lantern:": "1F3EE",
	":jack_o_lantern:": "1F383",
	":japan:": "1F5FE",
	":japanese_castle:": "1F3EF",
	":japanese_goblin:": "1F47A",
	":japanese_ogre:": "1F479",
	":jeans:": "1F456",
	":joy:": "1F602",
	":joy_cat:": "1F639",
	":key:": "1F511",
	":keycap_ten:": "1F51F",
	":kimono:": "1F458",
	":kiss:": "1F48B",
	":kissing:": "1F617",
	":kissing_cat:": "1F63D",
	":kissing_closed_eyes:": "1F61A",
	":kissing_heart:": "1F618",
	":kissing_smiling_eyes:": "1F619",
	":koala:": "1F428",
	":koko:": "1F201",
	":large_blue_circle:": "1F535",
	":large_blue_diamond:": "1F537",
	":large_orange_diamond:": "1F536",
	":last_quarter_moon:": "1F317",
	":last_quarter_moon_with_face:": "1F31C",
	":laughing:": "1F606",
	":leaves:": "1F343",
	":ledger:": "1F4D2",
	":left_luggage:": "1F6C5",
	":lemon:": "1F34B",
	":leopard:": "1F406",
	":light_rail:": "1F688",
	":link:": "1F517",
	":lips:": "1F444",
	":lipstick:": "1F484",
	":lock:": "1F512",
	":lock_with_ink_pen:": "1F50F",
	":lollipop:": "1F36D",
	":loudspeaker:": "1F4E2",
	":love_hotel:": "1F3E9",
	":love_letter:": "1F48C",
	":low_brightness:": "1F505",
	":mag:": "1F50D",
	":mag_right:": "1F50E",
	":mahjong:": "1F004",
	":mailbox:": "1F4EB",
	":mailbox_closed:": "1F4EA",
	":mailbox_with_mail:": "1F4EC",
	":mailbox_with_no_mail:": "1F4ED",
	":man:": "1F468",
	":man_with_gua_pi_mao:": "1F472",
	":man_with_turban:": "1F473",
	":mans_shoe:": "1F45E",
	":maple_leaf:": "1F341",
	":mask:": "1F637",
	":massage:": "1F486",
	":meat_on_bone:": "1F356",
	":mega:": "1F4E3",
	":melon:": "1F348",
	":memo:": "1F4DD",
	":mens:": "1F6B9",
	":metro:": "1F687",
	":microphone:": "1F3A4",
	":microscope:": "1F52C",
	":milky_way:": "1F30C",
	":minibus:": "1F690",
	":minidisc:": "1F4BD",
	":mobile_phone_off:": "1F4F4",
	":money_with_wings:": "1F4B8",
	":moneybag:": "1F4B0",
	":monkey:": "1F412",
	":monkey_face:": "1F435",
	":monorail:": "1F69D",
	":moon:": "1F319",
	":mortar_board:": "1F393",
	":mount_fuji:": "1F5FB",
	":mountain_bicyclist:": "1F6B5",
	":mountain_cableway:": "1F6A0",
	":mountain_railway:": "1F69E",
	":mouse:": "1F42D",
	":mouse2:": "1F401",
	":movie_camera:": "1F3A5",
	":moyai:": "1F5FF",
	":muscle:": "1F4AA",
	":mushroom:": "1F344",
	":musical_keyboard:": "1F3B9",
	":musical_note:": "1F3B5",
	":musical_score:": "1F3BC",
	":mute:": "1F507",
	":nail_care:": "1F485",
	":name_badge:": "1F4DB",
	":necktie:": "1F454",
	":neutral_face:": "1F610",
	":new:": "1F195",
	":new_moon:": "1F311",
	":new_moon_with_face:": "1F31A",
	":newspaper:": "1F4F0",
	":ng:": "1F196",
	":no_bell:": "1F515",
	":no_bicycles:": "1F6B3",
	":no_entry_sign:": "1F6AB",
	":no_good:": "1F645",
	":no_mobile_phones:": "1F4F5",
	":no_mouth:": "1F636",
	":no_pedestrians:": "1F6B7",
	":no_smoking:": "1F6AD",
	":non-potable_water:": "1F6B1",
	":nose:": "1F443",
	":notebook:": "1F4D3",
	":notebook_with_decorative_cover:": "1F4D4",
	":notes:": "1F3B6",
	":nut_and_bolt:": "1F529",
	":o2:": "1F17E",
	":ocean:": "1F30A",
	":octopus:": "1F419",
	":oden:": "1F362",
	":office:": "1F3E2",
	":ok:": "1F197",
	":ok_hand:": "1F44C",
	":ok_woman:": "1F646",
	":older_man:": "1F474",
	":older_woman:": "1F475",
	":on:": "1F51B",
	":oncoming_automobile:": "1F698",
	":oncoming_bus:": "1F68D",
	":oncoming_police_car:": "1F694",
	":oncoming_taxi:": "1F696",
	":open_book:": "1F4D6",
	":open_file_folder:": "1F4C2",
	":open_hands:": "1F450",
	":open_mouth:": "1F62E",
	":orange_book:": "1F4D9",
	":outbox_tray:": "1F4E4",
	":ox:": "1F402",
	":package:": "1F4E6",
	":page_facing_up:": "1F4C4",
	":page_with_curl:": "1F4C3",
	":pager:": "1F4DF",
	":palm_tree:": "1F334",
	":panda_face:": "1F43C",
	":paperclip:": "1F4CE",
	":parking:": "1F17F",
	":passport_control:": "1F6C2",
	":paw_prints:": "1F43E",
	":peach:": "1F351",
	":pear:": "1F350",
	//":pencil:":                            "1F4DD",
	":penguin:": "1F427",
	":pensive:": "1F614",
	":performing_arts:": "1F3AD",
	":persevere:": "1F623",
	":person_frowning:": "1F64D",
	":person_with_blond_hair:": "1F471",
	":person_with_pouting_face:": "1F64E",
	":pig:": "1F437",
	":pig2:": "1F416",
	":pig_nose:": "1F43D",
	":pill:": "1F48A",
	":pineapple:": "1F34D",
	":pizza:": "1F355",
	":point_down:": "1F447",
	":point_left:": "1F448",
	":point_right:": "1F449",
	":point_up_2:": "1F446",
	":police_car:": "1F693",
	":poodle:": "1F429",
	":poop:": "1F4A9",
	":post_office:": "1F3E3",
	":postal_horn:": "1F4EF",
	":postbox:": "1F4EE",
	":potable_water:": "1F6B0",
	":pouch:": "1F45D",
	":poultry_leg:": "1F357",
	":pound:": "1F4B7",
	":pouting_cat:": "1F63E",
	":pray:": "1F64F",
	":princess:": "1F478",
	":punch:": "1F44A",
	":purple_heart:": "1F49C",
	":purse:": "1F45B",
	":pushpin:": "1F4CC",
	":put_litter_in_its_place:": "1F6AE",
	":rabbit:": "1F430",
	":rabbit2:": "1F407",
	":racehorse:": "1F40E",
	":radio:": "1F4FB",
	":radio_button:": "1F518",
	":rage:": "1F621",
	//":railway_car:":                       "1F683",
	":rainbow:": "1F308",
	":raised_hands:": "1F64C",
	":raising_hand:": "1F64B",
	":ram:": "1F40F",
	":ramen:": "1F35C",
	":rat:": "1F400",
	":red_car:": "1F697",
	":red_circle:": "1F534",
	":relieved:": "1F60C",
	":repeat:": "1F501",
	":repeat_one:": "1F502",
	":restroom:": "1F6BB",
	":revolving_hearts:": "1F49E",
	":ribbon:": "1F380",
	":rice:": "1F35A",
	":rice_ball:": "1F359",
	":rice_cracker:": "1F358",
	":rice_scene:": "1F391",
	":ring:": "1F48D",
	":rocket:": "1F680",
	":roller_coaster:": "1F3A2",
	":rooster:": "1F413",
	":rose:": "1F339",
	":rotating_light:": "1F6A8",
	":round_pushpin:": "1F4CD",
	":rowboat:": "1F6A3",
	":rugby_football:": "1F3C9",
	":runner:": "1F3C3",
	":running:": "1F3C3",
	":running_shirt_with_sash:": "1F3BD",
	":sa:": "1F202",
	":sake:": "1F376",
	":sandal:": "1F461",
	":santa:": "1F385",
	":satellite:": "1F4E1",
	":satisfied:": "1F606",
	":saxophone:": "1F3B7",
	":school:": "1F3EB",
	":school_satchel:": "1F392",
	":scream:": "1F631",
	":scream_cat:": "1F640",
	":scroll:": "1F4DC",
	":seat:": "1F4BA",
	":see_no_evil:": "1F648",
	":seedling:": "1F331",
	":shaved_ice:": "1F367",
	":sheep:": "1F411",
	":shell:": "1F41A",
	":ship:": "1F6A2",
	":shirt:": "1F455",
    ":poo:": "1F4A9",
	":shoe:": "1F45E",
	":shower:": "1F6BF",
	":signal_strength:": "1F4F6",
	":six_pointed_star:": "1F52F",
	":ski:": "1F3BF",
	":skull:": "1F480",
	":sleeping:": "1F634",
	":sleepy:": "1F62A",
	":slot_machine:": "1F3B0",
	":small_blue_diamond:": "1F539",
	":small_orange_diamond:": "1F538",
	":small_red_triangle:": "1F53A",
	":small_red_triangle_down:": "1F53B",
	":smile:": "1F604",
	":smile_cat:": "1F638",
	":smiley:": "1F603",
	":smiley_cat:": "1F63A",
	":smiling_imp:": "1F608",
	":smirk:": "1F60F",
	":smirk_cat:": "1F63C",
	":smoking:": "1F6AC",
	":snail:": "1F40C",
	":snake:": "1F40D",
	":snowboarder:": "1F3C2",
	":sob:": "1F62D",
	":soon:": "1F51C",
	":sos:": "1F198",
	":sound:": "1F509",
	":space_invader:": "1F47E",
	":spaghetti:": "1F35D",
	":sparkler:": "1F387",
	":sparkling_heart:": "1F496",
	":speak_no_evil:": "1F64A",
	":speaker:": "1F50A",
	":speaker_off:": "1F508",
	":speech_balloon:": "1F4AC",
	":speedboat:": "1F6A4",
	":star2:": "1F31F",
	":stars:": "1F303",
	":station:": "1F689",
	":statue_of_liberty:": "1F5FD",
	":steam_locomotive:": "1F682",
	":stew:": "1F372",
	":straight_ruler:": "1F4CF",
	":strawberry:": "1F353",
	":stuck_out_tongue:": "1F61B",
	":stuck_out_tongue_closed_eyes:": "1F61D",
	":stuck_out_tongue_winking_eye:": "1F61C",
	":sun_with_face:": "1F31E",
	":sunflower:": "1F33B",
	":sunglasses:": "1F60E",
	":sunrise:": "1F305",
	":sunrise_over_mountains:": "1F304",
	":surfer:": "1F3C4",
	":sushi:": "1F363",
	":suspension_railway:": "1F69F",
	":sweat:": "1F613",
	":sweat_drops:": "1F4A6",
	":sweat_smile:": "1F605",
	":sweet_potato:": "1F360",
	":swimmer:": "1F3CA",
	":symbols:": "1F523",
	":syringe:": "1F489",
	":tada:": "1F389",
	":tanabata_tree:": "1F38B",
	":tangerine:": "1F34A",
	":taxi:": "1F695",
	":tea:": "1F375",
	":telephone_receiver:": "1F4DE",
	":telescope:": "1F52D",
	":tennis:": "1F3BE",
	":thought_balloon:": "1F4AD",
	":thumbsdown:": "1F44E",
	":thumbsup:": "1F44D",
	":ticket:": "1F3AB",
	":tiger:": "1F42F",
	":tiger2:": "1F405",
	":tired_face:": "1F62B",
	":toilet:": "1F6BD",
	":tokyo_tower:": "1F5FC",
	":tomato:": "1F345",
	":tongue:": "1F445",
	":top:": "1F51D",
	":tophat:": "1F3A9",
	":tractor:": "1F69C",
	":traffic_light:": "1F6A5",
	":train:": "1F683",
	":train2:": "1F686",
	":tram:": "1F68A",
	":triangular_flag_on_post:": "1F6A9",
	":triangular_ruler:": "1F4D0",
	":trident:": "1F531",
	":triumph:": "1F624",
	":trolleybus:": "1F68E",
	":trophy:": "1F3C6",
	":tropical_drink:": "1F379",
	":tropical_fish:": "1F420",
	":truck:": "1F69A",
	":trumpet:": "1F3BA",
	":tshirt:": "1F455",
	":tulip:": "1F337",
	":turtle:": "1F422",
	":tv:": "1F4FA",
	":twisted_rightwards_arrows:": "1F500",
	":two_hearts:": "1F495",
	":two_men_holding_hands:": "1F46C",
	":two_women_holding_hands:": "1F46D",
	":u5272:": "1F239",
	":u5408:": "1F234",
	":u55b6:": "1F23A",
	":u6307:": "1F22F",
	":u6708:": "1F237",
	":u6709:": "1F236",
	":u6e80:": "1F235",
	":u7121:": "1F21A",
	":u7533:": "1F238",
	":u7981:": "1F232",
	":u7a7a:": "1F233",
	":unamused:": "1F612",
	":underage:": "1F51E",
	":unlock:": "1F513",
	":up:": "1F199",
	":vertical_traffic_light:": "1F6A6",
	":vhs:": "1F4FC",
	":vibration_mode:": "1F4F3",
	":video_camera:": "1F4F9",
	":video_game:": "1F3AE",
	":violin:": "1F3BB",
	":volcano:": "1F30B",
	":vs:": "1F19A",
	":walking:": "1F6B6",
	":waning_crescent_moon:": "1F318",
	":waning_gibbous_moon:": "1F316",
	":water_buffalo:": "1F403",
	":watermelon:": "1F349",
	":wave:": "1F44B",
	":waxing_crescent_moon:": "1F312",
	":waxing_gibbous_moon:": "1F314",
	":wc:": "1F6BE",
	":weary:": "1F629",
	":wedding:": "1F492",
	":whale:": "1F433",
	":whale2:": "1F40B",
	":white_flower:": "1F4AE",
	":white_square_button:": "1F533",
	":wind_chime:": "1F390",
	":wine_glass:": "1F377",
	":wink:": "1F609",
	":wolf:": "1F43A",
	":woman:": "1F469",
	":womans_clothes:": "1F45A",
	":womans_hat:": "1F452",
	":womens:": "1F6BA",
	":worried:": "1F61F",
	":wrench:": "1F527",
	":yellow_heart:": "1F49B",
	":yen:": "1F4B4",
	":yum:": "1F60B",
	":zzz:": "1F4A4",
	// Missing country flags
	":jp:": "1f1ef-1f1f5",
	":kr:": "1f1f0-1f1f7",
	":cn:": "1f1e8-1f1f3",
	":us:": "1f1fa-1f1f8",
	":fr:": "1f1eb-1f1f7",
	":es:": "1f1ea-1f1f8",
	":it:": "1f1ee-1f1f9",
	":ru:": "1f1f7-1f1fa",
	":gb:": "1f1ec-1f1e7",
	":uk:": "1f1ec-1f1e7",
	":de:": "1f1e9-1f1ea",
	// Missing numbers
	":zero:": "30-20e3",
	":one:": "31-20e3",
	":two:": "32-20e3",
	":three:": "33-20e3",
	":four:": "34-20e3",
	":five:": "35-20e3",
	":six:": "36-20e3",
	":seven:": "37-20e3",
	":eight:": "38-20e3",
	":nine:": "39-20e3",
	// Missing symbols
	":railway_car:": "1f68b",
	":hash:": "23-20e3",
	":shooting-star:": "1F320",
	":key-a:": "1f1e6",
	":key-b:": "1f1e7",
	":key-c:": "1f1e8",
	":key-d:": "1f1e9",
	":key-e:": "1f1ea",
	":key-f:": "1f1eb",
	":key-g:": "1f1ec",
	":key-h:": "1f1ed",
	":key-i:": "1f1ee",
	":key-j:": "1f1ef",
	":key-k:": "1f1f0",
	":key-l:": "1f1f1",
	":key-m:": "1f1f2",
	":key-n:": "1f1f3",
	":key-o:": "1f1f4",
	":key-p:": "1f1f5",
	":key-q:": "1f1f6",
	":key-r:": "1f1f7",
	":key-s:": "1f1f8",
	":key-t:": "1f1f9",
	":key-u:": "1f1fa",
	":key-v:": "1f1fb",
	":key-w:": "1f1fc",
	":key-x:": "1f1fd",
	":key-y:": "1f1fe",
	":key-z:": "1f1ff",
};

var twemojis = [
	"1f004",
	"1f0cf",
	"1f170",
	"1f171",
	"1f17e",
	"1f17f",
	"1f18e",
	"1f191",
	"1f192",
	"1f193",
	"1f194",
	"1f195",
	"1f196",
	"1f197",
	"1f198",
	"1f199",
	"1f19a",
	"1f1e6",
	"1f1e7",
	"1f1e8-1f1f3",
	"1f1e8",
	"1f1e9-1f1ea",
	"1f1e9",
	"1f1ea-1f1f8",
	"1f1ea",
	"1f1eb-1f1f7",
	"1f1eb",
	"1f1ec-1f1e7",
	"1f1ec",
	"1f1ed",
	"1f1ee-1f1f9",
	"1f1ee",
	"1f1ef-1f1f5",
	"1f1ef",
	"1f1f0-1f1f7",
	"1f1f0",
	"1f1f1",
	"1f1f2",
	"1f1f3",
	"1f1f4",
	"1f1f5",
	"1f1f6",
	"1f1f7-1f1fa",
	"1f1f7",
	"1f1f8",
	"1f1f9",
	"1f1fa-1f1f8",
	"1f1fa",
	"1f1fb",
	"1f1fc",
	"1f1fd",
	"1f1fe",
	"1f1ff",
	"1f201",
	"1f202",
	"1f21a",
	"1f22f",
	"1f232",
	"1f233",
	"1f234",
	"1f235",
	"1f236",
	"1f237",
	"1f238",
	"1f239",
	"1f23a",
	"1f250",
	"1f251",
	"1f300",
	"1f301",
	"1f302",
	"1f303",
	"1f304",
	"1f305",
	"1f306",
	"1f307",
	"1f308",
	"1f309",
	"1f30a",
	"1f30b",
	"1f30c",
	"1f30d",
	"1f30e",
	"1f30f",
	"1f310",
	"1f311",
	"1f312",
	"1f313",
	"1f314",
	"1f315",
	"1f316",
	"1f317",
	"1f318",
	"1f319",
	"1f31a",
	"1f31b",
	"1f31c",
	"1f31d",
	"1f31e",
	"1f31f",
	"1f320",
	"1f330",
	"1f331",
	"1f332",
	"1f333",
	"1f334",
	"1f335",
	"1f337",
	"1f338",
	"1f339",
	"1f33a",
	"1f33b",
	"1f33c",
	"1f33d",
	"1f33e",
	"1f33f",
	"1f340",
	"1f341",
	"1f342",
	"1f343",
	"1f344",
	"1f345",
	"1f346",
	"1f347",
	"1f348",
	"1f349",
	"1f34a",
	"1f34b",
	"1f34c",
	"1f34d",
	"1f34e",
	"1f34f",
	"1f350",
	"1f351",
	"1f352",
	"1f353",
	"1f354",
	"1f355",
	"1f356",
	"1f357",
	"1f358",
	"1f359",
	"1f35a",
	"1f35b",
	"1f35c",
	"1f35d",
	"1f35e",
	"1f35f",
	"1f360",
	"1f361",
	"1f362",
	"1f363",
	"1f364",
	"1f365",
	"1f366",
	"1f367",
	"1f368",
	"1f369",
	"1f36a",
	"1f36b",
	"1f36c",
	"1f36d",
	"1f36e",
	"1f36f",
	"1f370",
	"1f371",
	"1f372",
	"1f373",
	"1f374",
	"1f375",
	"1f376",
	"1f377",
	"1f378",
	"1f379",
	"1f37a",
	"1f37b",
	"1f37c",
	"1f380",
	"1f381",
	"1f382",
	"1f383",
	"1f384",
	"1f385",
	"1f386",
	"1f387",
	"1f388",
	"1f389",
	"1f38a",
	"1f38b",
	"1f38c",
	"1f38d",
	"1f38e",
	"1f38f",
	"1f390",
	"1f391",
	"1f392",
	"1f393",
	"1f3a0",
	"1f3a1",
	"1f3a2",
	"1f3a3",
	"1f3a4",
	"1f3a5",
	"1f3a6",
	"1f3a7",
	"1f3a8",
	"1f3a9",
	"1f3aa",
	"1f3ab",
	"1f3ac",
	"1f3ad",
	"1f3ae",
	"1f3af",
	"1f3b0",
	"1f3b1",
	"1f3b2",
	"1f3b3",
	"1f3b4",
	"1f3b5",
	"1f3b6",
	"1f3b7",
	"1f3b8",
	"1f3b9",
	"1f3ba",
	"1f3bb",
	"1f3bc",
	"1f3bd",
	"1f3be",
	"1f3bf",
	"1f3c0",
	"1f3c1",
	"1f3c2",
	"1f3c3",
	"1f3c4",
	"1f3c6",
	"1f3c7",
	"1f3c8",
	"1f3c9",
	"1f3ca",
	"1f3e0",
	"1f3e1",
	"1f3e2",
	"1f3e3",
	"1f3e4",
	"1f3e5",
	"1f3e6",
	"1f3e7",
	"1f3e8",
	"1f3e9",
	"1f3ea",
	"1f3eb",
	"1f3ec",
	"1f3ed",
	"1f3ee",
	"1f3ef",
	"1f3f0",
	"1f400",
	"1f401",
	"1f402",
	"1f403",
	"1f404",
	"1f405",
	"1f406",
	"1f407",
	"1f408",
	"1f409",
	"1f40a",
	"1f40b",
	"1f40c",
	"1f40d",
	"1f40e",
	"1f40f",
	"1f410",
	"1f411",
	"1f412",
	"1f413",
	"1f414",
	"1f415",
	"1f416",
	"1f417",
	"1f418",
	"1f419",
	"1f41a",
	"1f41b",
	"1f41c",
	"1f41d",
	"1f41e",
	"1f41f",
	"1f420",
	"1f421",
	"1f422",
	"1f423",
	"1f424",
	"1f425",
	"1f426",
	"1f427",
	"1f428",
	"1f429",
	"1f42a",
	"1f42b",
	"1f42c",
	"1f42d",
	"1f42e",
	"1f42f",
	"1f430",
	"1f431",
	"1f432",
	"1f433",
	"1f434",
	"1f435",
	"1f436",
	"1f437",
	"1f438",
	"1f439",
	"1f43a",
	"1f43b",
	"1f43c",
	"1f43d",
	"1f43e",
	"1f440",
	"1f442",
	"1f443",
	"1f444",
	"1f445",
	"1f446",
	"1f447",
	"1f448",
	"1f449",
	"1f44a",
	"1f44b",
	"1f44c",
	"1f44d",
	"1f44e",
	"1f44f",
	"1f450",
	"1f451",
	"1f452",
	"1f453",
	"1f454",
	"1f455",
	"1f456",
	"1f457",
	"1f458",
	"1f459",
	"1f45a",
	"1f45b",
	"1f45c",
	"1f45d",
	"1f45e",
	"1f45f",
	"1f460",
	"1f461",
	"1f462",
	"1f463",
	"1f464",
	"1f465",
	"1f466",
	"1f467",
	"1f468",
	"1f469",
	"1f46a",
	"1f46b",
	"1f46c",
	"1f46d",
	"1f46e",
	"1f46f",
	"1f470",
	"1f471",
	"1f472",
	"1f473",
	"1f474",
	"1f475",
	"1f476",
	"1f477",
	"1f478",
	"1f479",
	"1f47a",
	"1f47b",
	"1f47c",
	"1f47d",
	"1f47e",
	"1f47f",
	"1f480",
	"1f481",
	"1f482",
	"1f483",
	"1f484",
	"1f485",
	"1f486",
	"1f487",
	"1f488",
	"1f489",
	"1f48a",
	"1f48b",
	"1f48c",
	"1f48d",
	"1f48e",
	"1f48f",
	"1f490",
	"1f491",
	"1f492",
	"1f493",
	"1f494",
	"1f495",
	"1f496",
	"1f497",
	"1f498",
	"1f499",
	"1f49a",
	"1f49b",
	"1f49c",
	"1f49d",
	"1f49e",
	"1f49f",
	"1f4a0",
	"1f4a1",
	"1f4a2",
	"1f4a3",
	"1f4a4",
	"1f4a5",
	"1f4a6",
	"1f4a7",
	"1f4a8",
	"1f4a9",
	"1f4aa",
	"1f4ab",
	"1f4ac",
	"1f4ad",
	"1f4ae",
	"1f4af",
	"1f4b0",
	"1f4b1",
	"1f4b2",
	"1f4b3",
	"1f4b4",
	"1f4b5",
	"1f4b6",
	"1f4b7",
	"1f4b8",
	"1f4b9",
	"1f4ba",
	"1f4bb",
	"1f4bc",
	"1f4bd",
	"1f4be",
	"1f4bf",
	"1f4c0",
	"1f4c1",
	"1f4c2",
	"1f4c3",
	"1f4c4",
	"1f4c5",
	"1f4c6",
	"1f4c7",
	"1f4c8",
	"1f4c9",
	"1f4ca",
	"1f4cb",
	"1f4cc",
	"1f4cd",
	"1f4ce",
	"1f4cf",
	"1f4d0",
	"1f4d1",
	"1f4d2",
	"1f4d3",
	"1f4d4",
	"1f4d5",
	"1f4d6",
	"1f4d7",
	"1f4d8",
	"1f4d9",
	"1f4da",
	"1f4db",
	"1f4dc",
	"1f4dd",
	"1f4de",
	"1f4df",
	"1f4e0",
	"1f4e1",
	"1f4e2",
	"1f4e3",
	"1f4e4",
	"1f4e5",
	"1f4e6",
	"1f4e7",
	"1f4e8",
	"1f4e9",
	"1f4ea",
	"1f4eb",
	"1f4ec",
	"1f4ed",
	"1f4ee",
	"1f4ef",
	"1f4f0",
	"1f4f1",
	"1f4f2",
	"1f4f3",
	"1f4f4",
	"1f4f5",
	"1f4f6",
	"1f4f7",
	"1f4f9",
	"1f4fa",
	"1f4fb",
	"1f4fc",
	"1f500",
	"1f501",
	"1f502",
	"1f503",
	"1f504",
	"1f505",
	"1f506",
	"1f507",
	"1f508",
	"1f509",
	"1f50a",
	"1f50b",
	"1f50c",
	"1f50d",
	"1f50e",
	"1f50f",
	"1f510",
	"1f511",
	"1f512",
	"1f513",
	"1f514",
	"1f515",
	"1f516",
	"1f517",
	"1f518",
	"1f519",
	"1f51a",
	"1f51b",
	"1f51c",
	"1f51d",
	"1f51e",
	"1f51f",
	"1f520",
	"1f521",
	"1f522",
	"1f523",
	"1f524",
	"1f525",
	"1f526",
	"1f527",
	"1f528",
	"1f529",
	"1f52a",
	"1f52b",
	"1f52c",
	"1f52d",
	"1f52e",
	"1f52f",
	"1f530",
	"1f531",
	"1f532",
	"1f533",
	"1f534",
	"1f535",
	"1f536",
	"1f537",
	"1f538",
	"1f539",
	"1f53a",
	"1f53b",
	"1f53c",
	"1f53d",
	"1f550",
	"1f551",
	"1f552",
	"1f553",
	"1f554",
	"1f555",
	"1f556",
	"1f557",
	"1f558",
	"1f559",
	"1f55a",
	"1f55b",
	"1f55c",
	"1f55d",
	"1f55e",
	"1f55f",
	"1f560",
	"1f561",
	"1f562",
	"1f563",
	"1f564",
	"1f565",
	"1f566",
	"1f567",
	"1f5fb",
	"1f5fc",
	"1f5fd",
	"1f5fe",
	"1f5ff",
	"1f600",
	"1f601",
	"1f602",
	"1f603",
	"1f604",
	"1f605",
	"1f606",
	"1f607",
	"1f608",
	"1f609",
	"1f60a",
	"1f60b",
	"1f60c",
	"1f60d",
	"1f60e",
	"1f60f",
	"1f610",
	"1f611",
	"1f612",
	"1f613",
	"1f614",
	"1f615",
	"1f616",
	"1f617",
	"1f618",
	"1f619",
	"1f61a",
	"1f61b",
	"1f61c",
	"1f61d",
	"1f61e",
	"1f61f",
	"1f620",
	"1f621",
	"1f622",
	"1f623",
	"1f624",
	"1f625",
	"1f626",
	"1f627",
	"1f628",
	"1f629",
	"1f62a",
	"1f62b",
	"1f62c",
	"1f62d",
	"1f62e",
	"1f62f",
	"1f630",
	"1f631",
	"1f632",
	"1f633",
	"1f634",
	"1f635",
	"1f636",
	"1f637",
	"1f638",
	"1f639",
	"1f63a",
	"1f63b",
	"1f63c",
	"1f63d",
	"1f63e",
	"1f63f",
	"1f640",
	"1f645",
	"1f646",
	"1f647",
	"1f648",
	"1f649",
	"1f64a",
	"1f64b",
	"1f64c",
	"1f64d",
	"1f64e",
	"1f64f",
	"1f680",
	"1f681",
	"1f682",
	"1f683",
	"1f684",
	"1f685",
	"1f686",
	"1f687",
	"1f688",
	"1f689",
	"1f68a",
	"1f68b",
	"1f68c",
	"1f68d",
	"1f68e",
	"1f68f",
	"1f690",
	"1f691",
	"1f692",
	"1f693",
	"1f694",
	"1f695",
	"1f696",
	"1f697",
	"1f698",
	"1f699",
	"1f69a",
	"1f69b",
	"1f69c",
	"1f69d",
	"1f69e",
	"1f69f",
	"1f6a0",
	"1f6a1",
	"1f6a2",
	"1f6a3",
	"1f6a4",
	"1f6a5",
	"1f6a6",
	"1f6a7",
	"1f6a8",
	"1f6a9",
	"1f6aa",
	"1f6ab",
	"1f6ac",
	"1f6ad",
	"1f6ae",
	"1f6af",
	"1f6b0",
	"1f6b1",
	"1f6b2",
	"1f6b3",
	"1f6b4",
	"1f6b5",
	"1f6b6",
	"1f6b7",
	"1f6b8",
	"1f6b9",
	"1f6ba",
	"1f6bb",
	"1f6bc",
	"1f6bd",
	"1f6be",
	"1f6bf",
	"1f6c0",
	"1f6c1",
	"1f6c2",
	"1f6c3",
	"1f6c4",
	"1f6c5",
	"203c",
	"2049",
	"2122",
	"2139",
	"2194",
	"2195",
	"2196",
	"2197",
	"2198",
	"2199",
	"21a9",
	"21aa",
	"23-20e3",
	"231a",
	"231b",
	"23e9",
	"23ea",
	"23eb",
	"23ec",
	"23f0",
	"23f3",
	"24c2",
	"25aa",
	"25ab",
	"25b6",
	"25c0",
	"25fb",
	"25fc",
	"25fd",
	"25fe",
	"2600",
	"2601",
	"260e",
	"2611",
	"2614",
	"2615",
	"261d",
	"263a",
	"2648",
	"2649",
	"264a",
	"264b",
	"264c",
	"264d",
	"264e",
	"264f",
	"2650",
	"2651",
	"2652",
	"2653",
	"2660",
	"2663",
	"2665",
	"2666",
	"2668",
	"267b",
	"267f",
	"2693",
	"26a0",
	"26a1",
	"26aa",
	"26ab",
	"26bd",
	"26be",
	"26c4",
	"26c5",
	"26ce",
	"26d4",
	"26ea",
	"26f2",
	"26f3",
	"26f5",
	"26fa",
	"26fd",
	"2702",
	"2705",
	"2708",
	"2709",
	"270a",
	"270b",
	"270c",
	"270f",
	"2712",
	"2714",
	"2716",
	"2728",
	"2733",
	"2734",
	"2744",
	"2747",
	"274c",
	"274e",
	"2753",
	"2754",
	"2755",
	"2757",
	"2764",
	"2795",
	"2796",
	"2797",
	"27a1",
	"27b0",
	"27bf",
	"2934",
	"2935",
	"2b05",
	"2b06",
	"2b07",
	"2b1b",
	"2b1c",
	"2b50",
	"2b55",
	"30-20e3",
	"3030",
	"303d",
	"31-20e3",
	"32-20e3",
	"3297",
	"3299",
	"33-20e3",
	"34-20e3",
	"35-20e3",
	"36-20e3",
	"37-20e3",
	"38-20e3",
	"39-20e3",
	"a9",
	"ae",
	"e50a"
];

var favs = [":laughing:", ":blush:", ":smiley:", ":relaxed:", ":smirk:", ":heart_eyes:", ":smile:", ":kissing_heart:", ":kissing_closed_eyes:"];

var people_tab = document.getElementById("people");
var nature_tab = document.getElementById("nature");
var objects_tab = document.getElementById("objects");
var places_tab = document.getElementById("places");
var symbols_tab = document.getElementById("symbols");

people_tab.style.display = "block";

var labels = document.getElementsByClassName("tablabel");
var emojiImages = document.getElementsByClassName("emojiimg");
var favImages = document.getElementsByClassName("favimg");

labels[0].classList.add("active");

function handler() {
	people_tab.style.display = "none";
	nature_tab.style.display = "none";
	objects_tab.style.display = "none";
	places_tab.style.display = "none";
	symbols_tab.style.display = "none";

	for (var i = 0; i < labels.length; i++) {
		labels[i].classList.remove("active");
	}

	this.classList.add("active");

	document.getElementById(this.id).style.display = "block";

	document.getElementById(this.id).scrollTop = 0;
}

populateFavs();

function reset() {
	people_tab.style.display = "none";
	nature_tab.style.display = "none";
	objects_tab.style.display = "none";
	places_tab.style.display = "none";
	symbols_tab.style.display = "none";

	for (var i = 0; i < labels.length; i++) {
		labels[i].classList.remove("active");
	}

	labels[0].classList.add("active");

	people_tab.style.display = "block";
	people_tab.scrollTop = 0;
}

function sendEmoji(text, favs) {
    try {
        EmojiView.SendEmoji(text, favs);
    } catch (e) {
        console.log("send emoji", text);
    }
}

function Debug(text) {
	try {
		EmojiView.Debug(text);
	} catch (e) {
		console.log("[DEBUG]", text);
	}
}

function populateFavs() {
	var id, img1, unicode, path;
	var favImages = document.getElementsByClassName("favimg");

	for (var i = 0; i < favs.length; i++) {
		id = favs[i];
		var img = favImages[i];
		unicode = unicode_map[id];

		path = "../emoji/36/" + unicode.toLowerCase() + ".png";

		img.setAttribute("title", id);
        img.setAttribute("data-name", id);

        img.style.backgroundImage = "url(" + path + ")";
	}
}

function emojiHandler() {
	var text = this.getAttribute("data-name");
    var index = favs.indexOf(text);
    var unicode = unicode_map[text];

    if (index == -1)
    {
        favs.pop();
        favs.unshift(text);
        populateFavs();
    }

    sendEmoji(unicode, favs);
}

function setFavs(text) {
	var tmp = text.split(",");
    if (tmp.length === favs.length)
		favs = tmp;
	populateFavs();
}

function setTabLabels(text) {
	var tmp = text.split(";");
	for (var i = 0; i < tmp.length && i < labels.length; i++) {
		labels[i].title = tmp[i];
	}
}

function favEmojiHandler() {
	var text = this.getAttribute("data-name");
    var unicode = unicode_map[text];
    sendEmoji(unicode, favs);
}

for (var i = 0; i < labels.length; i++) {
	labels[i].onclick = handler;
}

for (var i = 0; i < emojiImages.length; i++) {
	emojiImages[i].onclick = emojiHandler;
}

for (var i = 0; i < favImages.length; i++) {
	favImages[i].onclick = favEmojiHandler;
}
